library(stockassessment)
load("run/model.RData")
FC<-list()


Ry<-1998:max(fit$data$years)
# use last 3 years for fishing selectivity and for average weight, maturity, M, etc. - this is what is specified in annex
Sy<-max(fit$data$years) +(-2:0)
Ay<-max(fit$data$years) +(-2:0)

#This is wanted catch quota not adjusted for landings obligation in 3a46. Not fully under landing obligation unter 2019
TAC <- 116008  

#ref pts
Fmsy<-0.363
Flim<-0.620
Fpa<-0.446
#Bpa<-149098
#Blim<-107297
#Btrigger<-149098
MAP.FMSY.lower<-0.210
MAP.FMSY.upper<-0.536



set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,Fmsy,Fmsy), ave.years=Ay, rec.years=Ry, label="Fsq, then Fmsy", overwriteSelYears=Sy, splitLD=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,MAP.FMSY.lower,MAP.FMSY.lower), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,MAP.FMSY.upper,MAP.FMSY.upper), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_upper", overwriteSelYears=Sy, splitLD=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.000001, 0.000001), label="Fsq, then zero")
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,Fpa,Fpa), ave.years=Ay, rec.years=Ry, label="Fsq, then Fpa", overwriteSelYears=Sy, splitLD=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,Flim,Flim), ave.years=Ay, rec.years=Ry, label="Fsq, then Flim", overwriteSelYears=Sy, splitLD=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,1.35322,1.35322), ave.years=Ay, rec.years=Ry, label="Fsq, then SSB(2020)=Blim", overwriteSelYears=Sy, splitLD=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.972695,0.972695), ave.years=Ay, rec.years=Ry, label="Fsq, then SSB(2020)=MSY Btrigger", overwriteSelYears=Sy, splitLD=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.972695,0.972695), ave.years=Ay, rec.years=Ry, label="Fsq, then SSB(2020)=Bpa", overwriteSelYears=Sy, splitLD=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,1,1), fval=c(NA,NA,NA,NA), ave.years=Ay, rec.years=Ry, label="Fsq, then F2018", overwriteSelYears=Sy, splitLD=TRUE)
##### F in 0.01 steps btw Flower and Fupper
set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,MAP.FMSY.lower,MAP.FMSY.lower), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.22,0.22), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.23,0.23), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.24,0.24), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.25,0.25), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.26,0.26), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.27,0.27), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.28,0.28), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.29,0.29), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.3,0.3), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.31,0.31), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.32,0.32), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.33,0.33), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.34,0.34), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.35,0.35), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.36,0.36), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.37,0.37), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.38,0.38), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.39,0.39), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.4,0.4), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.41,0.41), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.42,0.42), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.43,0.43), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.44,0.44), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.45,0.45), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.46,0.46), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.47,0.47), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.48,0.48), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.49,0.49), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.5,0.5), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.51,0.51), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.52,0.52), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.53,0.53), ave.years=Ay, rec.years=Ry, label="Fsq, then MAP FMSY_lower", overwriteSelYears=Sy, splitLD=TRUE)
##
# catch values are a bit off if aim for TAC...
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), catchval=c(NA,NA,TAC,TAC), ave.years=Ay, rec.years=Ry, label="Fsq, then TAC2018", overwriteSelYears=Sy, splitLD=TRUE)
# #FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.403,0.410), ave.years=Ay, rec.years=Ry, label="Fsq, then TAC2018", overwriteSelYears=Sy, spli


save(FC, file="run/forecast.RData")
